export type Decoded = Record<string, any> | Array<any> | string | number;
export interface Decoder {
    (data: Uint8Array | string): Decoded | null;
    (data: Uint8Array | string, encoding: string): Decoded | null;
    (data: Uint8Array | string, start: number, encoding: string): Decoded | null;
    (data: Uint8Array | string, start: number, end: number, encoding: string): Decoded | null;
    data: Uint8Array | null;
    bytes: number;
    position: number;
    encoding: string | null;
    next: () => Record<string, any> | Array<any> | Uint8Array | string | number | null;
    dictionary: () => Record<string, any> | null;
    list: () => any[];
    buffer: () => Uint8Array | string;
    find: (ch: number) => number | null;
    integer: () => number;
}
/**
 * Decode bencoded data.
 *
 * @param  {Uint8Array|string} data The buffer to decode
 * @param  {number} [start] Optional start index
 * @param  {number} [end] Optional end index
 * @param  {string} [encoding] Optional encoding type (utf8, etc)
 * @return {Decoded}
 */
declare const decode: Decoder;
export default decode;
//# sourceMappingURL=decode.d.ts.map